diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_snmp.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_snmp.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_snmp.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_snmp.c	2013-05-24 10:12:36.626168200 +0200
@@ -45,11 +45,11 @@ vrrp_snmp_script(struct variable *vp, oi
 		 int exact, size_t *var_len, WriteMethod **write_method)
 {
         static unsigned long long_ret;
-	vrrp_script *scr;
+	vrrp_script_t *scr;
 
-	if ((scr = (vrrp_script *)snmp_header_list_table(vp, name, length, exact,
-							 var_len, write_method,
-							 vrrp_data->vrrp_script)) == NULL)
+	if ((scr = (vrrp_script_t *)snmp_header_list_table(vp, name, length, exact,
+							   var_len, write_method,
+							   vrrp_data->vrrp_script)) == NULL)
 		return NULL;
 
 	switch (vp->magic) {
@@ -146,13 +146,13 @@ vrrp_header_ar_table(struct variable *vp
 					continue;
 				}
 			}
-			l2 = ((vrrp_rt*)ELEMENT_DATA(e1))->vip;
+			l2 = ((vrrp_t *) ELEMENT_DATA(e1))->vip;
 			current[1] = 0;
 			nextstate = HEADER_STATE_EXCLUDED_VIRTUAL_ADDRESS;
 			break;
 		case HEADER_STATE_EXCLUDED_VIRTUAL_ADDRESS:
 			/* Try excluded virtual addresses */
-			l2 = ((vrrp_rt*)ELEMENT_DATA(e1))->evip;
+			l2 = ((vrrp_t *)ELEMENT_DATA(e1))->evip;
 			nextstate = HEADER_STATE_VIRTUAL_ADDRESS;
 			break;
 		case HEADER_STATE_STATIC_ROUTE:
@@ -171,7 +171,7 @@ vrrp_header_ar_table(struct variable *vp
 			curinstance++;
 			if (e1 == NULL)
 				e1 = LIST_HEAD(vrrp_data->vrrp);
-			l2 = ((vrrp_rt*)ELEMENT_DATA(e1))->vroutes;
+			l2 = ((vrrp_t *)ELEMENT_DATA(e1))->vroutes;
 			current[1] = 0;
 			nextstate = HEADER_STATE_VIRTUAL_ROUTE;
 			break;
@@ -224,10 +224,10 @@ vrrp_snmp_address(struct variable *vp, o
 		 int exact, size_t *var_len, WriteMethod **write_method)
 {
         static unsigned long long_ret;
-	ip_address *addr;
+	ip_address_t *addr;
 	int state = HEADER_STATE_STATIC_ADDRESS;
 
-	if ((addr = (ip_address *)
+	if ((addr = (ip_address_t *)
 	     vrrp_header_ar_table(vp, name, length, exact,
 				  var_len, write_method,
 				  &state)) == NULL)
@@ -290,10 +290,10 @@ vrrp_snmp_route(struct variable *vp, oid
 		 int exact, size_t *var_len, WriteMethod **write_method)
 {
         static unsigned long long_ret;
-	ip_route *route;
+	ip_route_t *route;
 	int state = HEADER_STATE_STATIC_ROUTE;
 
-	if ((route = (ip_route *)
+	if ((route = (ip_route_t *)
 	     vrrp_header_ar_table(vp, name, length, exact,
 				  var_len, write_method,
 				  &state)) == NULL)
@@ -365,9 +365,9 @@ vrrp_snmp_syncgroup(struct variable *vp,
 		 int exact, size_t *var_len, WriteMethod **write_method)
 {
         static unsigned long long_ret;
-	vrrp_sgroup *group;
+	vrrp_sgroup_t *group;
 
-	if ((group = (vrrp_sgroup *)
+	if ((group = (vrrp_sgroup_t *)
 	     snmp_header_list_table(vp, name, length, exact,
 				    var_len, write_method,
 				    vrrp_data->vrrp_sync_group)) == NULL)
@@ -430,7 +430,7 @@ vrrp_snmp_syncgroupmember(struct variabl
 	int curgroup, curinstance;
 	char *instance, *binstance = NULL;
 	element e;
-	vrrp_sgroup *group;
+	vrrp_sgroup_t *group;
 
         if ((result = snmp_oid_compare(name, *length, vp->name, vp->namelen)) < 0) {
                 memcpy(name, vp->name, sizeof(oid) * vp->namelen);
@@ -497,12 +497,12 @@ vrrp_snmp_syncgroupmember(struct variabl
 	return (u_char*)binstance;
 }
 
-static vrrp_rt*
+static vrrp_t *
 _get_instance(oid *name, size_t name_len)
 {
 	int instance;
 	element e;
-	vrrp_rt *vrrp = NULL;
+	vrrp_t *vrrp = NULL;
 
 	if (name_len < 1) return NULL;
 	instance = name[name_len - 1];
@@ -519,7 +519,7 @@ vrrp_snmp_instance_priority(int action,
 			    u_char *var_val, u_char var_val_type, size_t var_val_len,
 			    u_char *statP, oid *name, size_t name_len)
 {
-	vrrp_rt *vrrp = NULL;
+	vrrp_t *vrrp = NULL;
 	switch (action) {
 	case RESERVE1:
 		/* Check that the proposed priority is acceptable */
@@ -560,7 +560,7 @@ vrrp_snmp_instance_preempt(int action,
 			   u_char *var_val, u_char var_val_type, size_t var_val_len,
 			   u_char *statP, oid *name, size_t name_len)
 {
-	vrrp_rt *vrrp = NULL;
+	vrrp_t *vrrp = NULL;
 	switch (action) {
 	case RESERVE1:
 		/* Check that the proposed value is acceptable */
@@ -608,9 +608,9 @@ vrrp_snmp_instance(struct variable *vp,
 		   int exact, size_t *var_len, WriteMethod **write_method)
 {
         static unsigned long long_ret;
-	vrrp_rt *rt;
+	vrrp_t *rt;
 
-	if ((rt = (vrrp_rt *)snmp_header_list_table(vp, name, length, exact,
+	if ((rt = (vrrp_t *)snmp_header_list_table(vp, name, length, exact,
 						    var_len, write_method,
 						    vrrp_data->vrrp)) == NULL)
 		return NULL;
@@ -734,8 +734,8 @@ vrrp_snmp_trackedinterface(struct variab
         int result, target_len;
 	int curinstance;
 	element e1, e2;
-	vrrp_rt *instance;
-	tracked_if *ifp, *bifp = NULL;
+	vrrp_t *instance;
+	tracked_if_t *ifp, *bifp = NULL;
 
         if ((result = snmp_oid_compare(name, *length, vp->name, vp->namelen)) < 0) {
                 memcpy(name, vp->name, sizeof(oid) * vp->namelen);
@@ -817,8 +817,8 @@ vrrp_snmp_trackedscript(struct variable
         int result, target_len;
 	int curinstance, curscr;
 	element e1, e2;
-	vrrp_rt *instance;
-	tracked_sc *scr, *bscr = NULL;
+	vrrp_t *instance;
+	tracked_sc_t *scr, *bscr = NULL;
 
         if ((result = snmp_oid_compare(name, *length, vp->name, vp->namelen)) < 0) {
                 memcpy(name, vp->name, sizeof(oid) * vp->namelen);
@@ -1054,7 +1054,7 @@ vrrp_snmp_agent_close()
 }
 
 void
-vrrp_snmp_instance_trap(vrrp_rt *vrrp)
+vrrp_snmp_instance_trap(vrrp_t *vrrp)
 {
 	/* OID of the notification */
 	oid notification_oid[] = { VRRP_OID, 9, 0, 2 };
@@ -1122,7 +1122,7 @@ vrrp_snmp_instance_trap(vrrp_rt *vrrp)
 }
 
 void
-vrrp_snmp_group_trap(vrrp_sgroup *group)
+vrrp_snmp_group_trap(vrrp_sgroup_t *group)
 {
 	/* OID of the notification */
 	oid notification_oid[] = { VRRP_OID, 9, 0, 1 };
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_sync.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_sync.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_sync.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_sync.c	2013-05-24 10:12:36.628168400 +0200
@@ -32,7 +32,7 @@
 
 /* Compute the new instance sands */
 void
-vrrp_init_instance_sands(vrrp_rt * vrrp)
+vrrp_init_instance_sands(vrrp_t * vrrp)
 {
 	set_time_now();
 
@@ -50,10 +50,10 @@ vrrp_init_instance_sands(vrrp_rt * vrrp)
 }
 
 /* Instance name lookup */
-vrrp_rt *
+vrrp_t *
 vrrp_get_instance(char *iname)
 {
-	vrrp_rt *vrrp;
+	vrrp_t *vrrp;
 	list l = vrrp_data->vrrp;
 	element e;
 
@@ -67,9 +67,9 @@ vrrp_get_instance(char *iname)
 
 /* Set instances group pointer */
 void
-vrrp_sync_set_group(vrrp_sgroup *vgroup)
+vrrp_sync_set_group(vrrp_sgroup_t *vgroup)
 {
-	vrrp_rt *vrrp;
+	vrrp_t *vrrp;
 	char *str;
 	int i;
 
@@ -87,9 +87,9 @@ vrrp_sync_set_group(vrrp_sgroup *vgroup)
 
 /* All interface are UP in the same group */
 int
-vrrp_sync_group_up(vrrp_sgroup * vgroup)
+vrrp_sync_group_up(vrrp_sgroup_t * vgroup)
 {
-	vrrp_rt *vrrp;
+	vrrp_t *vrrp;
 	element e;
 	list l = vgroup->index_list;
 	int is_up = 0;
@@ -110,7 +110,7 @@ vrrp_sync_group_up(vrrp_sgroup * vgroup)
 
 /* SMTP alert group notifier */
 void
-vrrp_sync_smtp_notifier(vrrp_sgroup *vgroup)
+vrrp_sync_smtp_notifier(vrrp_sgroup_t *vgroup)
 {
 	if (vgroup->smtp_alert) {
 		if (GROUP_STATE(vgroup) == VRRP_STATE_MAST)
@@ -126,9 +126,9 @@ vrrp_sync_smtp_notifier(vrrp_sgroup *vgr
 
 /* Leaving fault state */
 int
-vrrp_sync_leave_fault(vrrp_rt * vrrp)
+vrrp_sync_leave_fault(vrrp_t * vrrp)
 {
-	vrrp_sgroup *vgroup = vrrp->sync;
+	vrrp_sgroup_t *vgroup = vrrp->sync;
 
 	if (vrrp_sync_group_up(vgroup)) {
 		log_message(LOG_INFO, "VRRP_Group(%s) Leaving FAULT state",
@@ -140,10 +140,10 @@ vrrp_sync_leave_fault(vrrp_rt * vrrp)
 
 /* Check transition to master state */
 int
-vrrp_sync_goto_master(vrrp_rt * vrrp)
+vrrp_sync_goto_master(vrrp_t * vrrp)
 {
-	vrrp_rt *isync;
-	vrrp_sgroup *vgroup = vrrp->sync;
+	vrrp_t *isync;
+	vrrp_sgroup_t *vgroup = vrrp->sync;
 	list l = vgroup->index_list;
 	element e;
 
@@ -165,10 +165,10 @@ vrrp_sync_goto_master(vrrp_rt * vrrp)
 }
 
 void
-vrrp_sync_master_election(vrrp_rt * vrrp)
+vrrp_sync_master_election(vrrp_t * vrrp)
 {
-	vrrp_rt *isync;
-	vrrp_sgroup *vgroup = vrrp->sync;
+	vrrp_t *isync;
+	vrrp_sgroup_t *vgroup = vrrp->sync;
 	list l = vgroup->index_list;
 	element e;
 
@@ -195,10 +195,10 @@ vrrp_sync_master_election(vrrp_rt * vrrp
 }
 
 void
-vrrp_sync_backup(vrrp_rt * vrrp)
+vrrp_sync_backup(vrrp_t * vrrp)
 {
-	vrrp_rt *isync;
-	vrrp_sgroup *vgroup = vrrp->sync;
+	vrrp_t *isync;
+	vrrp_sgroup_t *vgroup = vrrp->sync;
 	list l = vgroup->index_list;
 	element e;
 
@@ -226,10 +226,10 @@ vrrp_sync_backup(vrrp_rt * vrrp)
 }
 
 void
-vrrp_sync_master(vrrp_rt * vrrp)
+vrrp_sync_master(vrrp_t * vrrp)
 {
-	vrrp_rt *isync;
-	vrrp_sgroup *vgroup = vrrp->sync;
+	vrrp_t *isync;
+	vrrp_sgroup_t *vgroup = vrrp->sync;
 	list l = vgroup->index_list;
 	element e;
 
@@ -261,10 +261,10 @@ vrrp_sync_master(vrrp_rt * vrrp)
 }
 
 void
-vrrp_sync_fault(vrrp_rt * vrrp)
+vrrp_sync_fault(vrrp_t * vrrp)
 {
-	vrrp_rt *isync;
-	vrrp_sgroup *vgroup = vrrp->sync;
+	vrrp_t *isync;
+	vrrp_sgroup_t *vgroup = vrrp->sync;
 	list l = vgroup->index_list;
 	element e;
 
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_track.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_track.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_track.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_track.c	2013-05-24 10:12:36.629168400 +0200
@@ -31,14 +31,14 @@
 void
 dump_track(void *track_data)
 {
-	tracked_if *tip = track_data;
+	tracked_if_t *tip = track_data;
 	log_message(LOG_INFO, "     %s weight %d", IF_NAME(tip->ifp), tip->weight);
 }
 void
 alloc_track(list track_list, vector_t *strvec)
 {
-	interface *ifp = NULL;
-	tracked_if *tip = NULL;
+	interface_t *ifp = NULL;
+	tracked_if_t *tip = NULL;
 	int weight = 0;
 	char *tracked = vector_slot(strvec, 0);
 
@@ -60,18 +60,18 @@ alloc_track(list track_list, vector_t *s
 		}
 	}
 
-	tip         = (tracked_if *) MALLOC(sizeof (tracked_if));
+	tip         = (tracked_if_t *) MALLOC(sizeof(tracked_if_t));
 	tip->ifp    = ifp;
 	tip->weight = weight;
 
 	list_add(track_list, tip);
 }
 
-vrrp_script *
+vrrp_script_t *
 find_script_by_name(char *name)
 {
 	element e;
-	vrrp_script *scr;
+	vrrp_script_t *scr;
 
 	if (LIST_ISEMPTY(vrrp_data->vrrp_script))
 		return NULL;
@@ -88,14 +88,14 @@ find_script_by_name(char *name)
 void
 dump_track_script(void *track_data)
 {
-	tracked_sc *tsc = track_data;
+	tracked_sc_t *tsc = track_data;
 	log_message(LOG_INFO, "     %s weight %d", tsc->scr->sname, tsc->weight);
 }
 void
 alloc_track_script(list track_list, vector_t *strvec)
 {
-	vrrp_script *vsc = NULL;
-	tracked_sc *tsc = NULL;
+	vrrp_script_t *vsc = NULL;
+	tracked_sc_t *tsc = NULL;
 	int weight = 0;
 	char *tracked = vector_slot(strvec, 0);
 
@@ -121,7 +121,7 @@ alloc_track_script(list track_list, vect
 		}
 	}
 
-	tsc         = (tracked_sc *) MALLOC(sizeof (tracked_sc));
+	tsc         = (tracked_sc_t *) MALLOC(sizeof(tracked_sc_t));
 	tsc->scr    = vsc;
 	tsc->weight = weight;
 	vsc->inuse++;
@@ -133,7 +133,7 @@ int
 vrrp_tracked_up(list l)
 {
 	element e;
-	tracked_if *tip;
+	tracked_if_t *tip;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		tip = ELEMENT_DATA(e);
@@ -149,7 +149,7 @@ void
 vrrp_log_tracked_down(list l)
 {
 	element e;
-	tracked_if *tip;
+	tracked_if_t *tip;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		tip = ELEMENT_DATA(e);
@@ -170,7 +170,7 @@ int
 vrrp_tracked_weight(list l)
 {
 	element e;
-	tracked_if *tip;
+	tracked_if_t *tip;
 	int weight = 0;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
@@ -192,7 +192,7 @@ int
 vrrp_script_up(list l)
 {
 	element e;
-	tracked_sc *tsc;
+	tracked_sc_t *tsc;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		tsc = ELEMENT_DATA(e);
@@ -215,7 +215,7 @@ int
 vrrp_script_weight(list l)
 {
 	element e;
-	tracked_sc *tsc;
+	tracked_sc_t *tsc;
 	int weight = 0;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_vmac.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_vmac.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_vmac.c	2012-08-17 01:21:28.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_vmac.c	2013-05-24 10:12:36.631168500 +0200
@@ -35,7 +35,7 @@ static const char *ll_kind = "macvlan";
 #ifdef _HAVE_VRRP_VMAC_
 /* Link layer handling */
 static int
-netlink_link_setlladdr(vrrp_rt *vrrp)
+netlink_link_setlladdr(vrrp_t *vrrp)
 {
 	int status = 1;
 	u_char ll_addr[ETH_ALEN] = {0x00, 0x00, 0x5e, 0x00, 0x01, vrrp->vrid};
@@ -64,7 +64,7 @@ netlink_link_setlladdr(vrrp_rt *vrrp)
 }
 
 static int
-netlink_link_setmode(vrrp_rt *vrrp)
+netlink_link_setmode(vrrp_t *vrrp)
 {
 	int status = 1;
 	struct {
@@ -108,7 +108,7 @@ netlink_link_setmode(vrrp_rt *vrrp)
 }
 
 static int
-netlink_link_up(vrrp_rt *vrrp)
+netlink_link_up(vrrp_t *vrrp)
 {
 	int status = 1;
 	struct {
@@ -135,11 +135,11 @@ netlink_link_up(vrrp_rt *vrrp)
 #endif
 
 int
-netlink_link_add_vmac(vrrp_rt *vrrp)
+netlink_link_add_vmac(vrrp_t *vrrp)
 {
 #ifdef _HAVE_VRRP_VMAC_
 	struct rtattr *linkinfo;
-	interface *ifp;
+	interface_t *ifp;
 	char ifname[IFNAMSIZ];
 	struct {
 		struct nlmsghdr n;
@@ -208,7 +208,7 @@ netlink_link_add_vmac(vrrp_rt *vrrp)
 }
 
 int
-netlink_link_del_vmac(vrrp_rt *vrrp)
+netlink_link_del_vmac(vrrp_t *vrrp)
 {
 	int status = 1;
 
diff -rupN keepalived-1.2.7/lib/buffer.c keepalived-1.2.7-unicast/lib/buffer.c
--- keepalived-1.2.7/lib/buffer.c	1970-01-01 01:00:00.000000000 +0100
+++ keepalived-1.2.7-unicast/lib/buffer.c	2013-05-24 10:12:36.635168800 +0200
@@ -0,0 +1,428 @@
+/*
+ * Soft:        Keepalived is a failover program for the LVS project
+ *              <www.linuxvirtualserver.org>. It monitor & manipulate
+ *              a loadbalanced server pool using multi-layer checks.
+ *
+ * Part:        Buffer structure manipulation.
+ *		This code is coming from quagga.net.
+ *
+ * Author:      Alexandre Cassen, <acassen@linux-vs.org>
+ *
+ *              This program is distributed in the hope that it will be useful,
+ *              but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ *              See the GNU General Public License for more details.
+ *
+ *              This program is free software; you can redistribute it and/or
+ *              modify it under the terms of the GNU General Public License
+ *              as published by the Free Software Foundation; either version
+ *              2 of the License, or (at your option) any later version.
+ *
+ * Copyright (C) 2001-2012 Alexandre Cassen, <acassen@linux-vs.org>
+ */
+#include <stddef.h>
+#include <unistd.h>
+#include <stdint.h>
+#include <errno.h>
+#include <sys/uio.h>
+
+#include "buffer.h"
+#include "memory.h"
+
+/* Create a new buffer. Memory will be allocated in chunks of the given
+ * size.  If the argument is 0, the library will supply a reasonable
+ * default size suitable for buffering socket I/O.
+ */
+buffer_t *
+buffer_new(size_t size)
+{
+	buffer_t *b;
+
+	b = (buffer_t *) MALLOC(sizeof(buffer_t));
+
+	if (size) {
+		b->size = size;
+	} else {
+		static size_t default_size;
+		if (!default_size) {
+			long pgsz = sysconf(_SC_PAGESIZE);
+			default_size = ((((BUFFER_SIZE_DEFAULT-1)/pgsz)+1)*pgsz);
+		}
+		b->size = default_size;
+	}
+
+	return b;
+}
+
+/* Free all data in the buffer. */
+void
+buffer_free(buffer_t *b)
+{
+	buffer_reset(b);
+	FREE(b);
+}
+
+/* Combine all accumulated (and unflushed) data inside the buffer into a
+ * single NUL-terminated string allocated using XMALLOC(MTYPE_TMP).  Note
+ * that this function does not alter the state of the buffer, so the data
+ * is still inside waiting to be flushed.
+ */
+char *
+buffer_getstr(buffer_t *b)
+{
+	size_t totlen = 0;
+	buffer_data_t *data;
+	char *s, *p;
+
+	for (data = b->head; data; data = data->next)
+		totlen += data->cp - data->sp;
+
+	if (!(s = (char *) MALLOC(totlen+1)))
+		return NULL;
+
+	p = s;
+	for (data = b->head; data; data = data->next) {
+		memcpy(p, data->data + data->sp, data->cp - data->sp);
+		p += data->cp - data->sp;
+	}
+	*p = '\0';
+
+	return s;
+}
+
+/* Returns 1 if there is no pending data in the buffer.
+ * Otherwise returns 0.
+ */
+int
+buffer_empty(buffer_t *b)
+{
+	return (b->head == NULL);
+}
+
+/* Clear and free all allocated data. */
+void
+buffer_reset(buffer_t *b)
+{
+	buffer_data_t *data, *next;
+
+	for (data = b->head; data; data = next) {
+		next = data->next;
+		FREE(data);
+	}
+
+	b->head = b->tail = NULL;
+}
+
+/* Add buffer_data to the end of buffer. */
+static buffer_data_t *
+buffer_add(buffer_t *b)
+{
+	buffer_data_t *d;
+
+	d = (buffer_data_t *) MALLOC(offsetof(buffer_data_t, data[b->size]));
+	d->cp = d->sp = 0;
+	d->next = NULL;
+
+	if (b->tail)
+		b->tail->next = d;
+	else
+		b->head = d;
+	b->tail = d;
+
+	return d;
+}
+
+/* Add the given data to the end of the buffer. */
+void
+buffer_put(buffer_t *b, const void *p, size_t size)
+{
+	buffer_data_t *data = b->tail;
+	const char *ptr = p;
+
+	/* We use even last one byte of data buffer. */
+	while (size) {
+		size_t chunk;
+
+		/* If there is no data buffer add it. */
+		if (data == NULL || data->cp == b->size)
+			data = buffer_add(b);
+
+		chunk = ((size <= (b->size - data->cp)) ? size : (b->size - data->cp));
+		memcpy((data->data + data->cp), ptr, chunk);
+		size -= chunk;
+		ptr += chunk;
+		data->cp += chunk;
+	}
+}
+
+/* Add a single character to the end of the buffer. */
+void
+buffer_putc(buffer_t *b, uint8_t c)
+{
+	buffer_put(b, &c, 1);
+}
+
+/* Add a NUL-terminated string to the end of the buffer. */
+void
+buffer_putstr(buffer_t *b, const char *c)
+{
+	buffer_put(b, c, strlen(c));
+}
+
+/* Call buffer_flush_available repeatedly until either all data has been
+ * flushed, or an I/O error has been encountered, or the operation would
+ * block.
+ */
+buffer_status_t
+buffer_flush_all(buffer_t *b, int fd)
+{
+ 	buffer_status_t ret;
+	buffer_data_t *head;
+	size_t head_sp;
+
+	if (!b->head)
+		return BUFFER_EMPTY;
+
+	/* Flush all data. */
+	head_sp = (head = b->head)->sp;
+	while ((ret = buffer_flush_available(b, fd)) == BUFFER_PENDING) {
+		if ((b->head == head) && (head_sp == head->sp) && (errno != EINTR)) {
+			/* No data was flushed, so kernel buffer must be full. */
+			return ret;
+		}
+
+		head_sp = (head = b->head)->sp;
+	}
+
+	return ret;
+}
+
+/* Attempt to write enough data to the given fd to fill a window of the
+ * given width and height (and remove the data written from the buffer).
+ *
+ * If !no_more, then a message saying " --More-- " is appended.
+ * If erase is true, then first overwrite the previous " --More-- " message
+ * with spaces.
+ *
+ * Any write error (including EAGAIN or EINTR) will cause this function
+ * to return -1 (because the logic for handling the erase and more features
+ * is too complicated to retry the write later).
+ */
+buffer_status_t
+buffer_flush_window(buffer_t *b, int fd, int width, int height,
+                    int erase_flag, int no_more_flag)
+{
+	int nbytes = 0, iov_alloc, iov_index, column;
+	struct iovec *iov;
+	struct iovec small_iov[3];
+	char more[] = " --More-- ";
+	char erase[] = { 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
+			 ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
+			 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08};
+	buffer_data_t *data;
+
+	if (!b->head)
+		return BUFFER_EMPTY;
+
+	if (height < 1) {
+		height = 1;
+	} else if (height >= 2) {
+		height--;
+	}
+
+	if (width < 1) {
+		width = 1;
+	}
+
+	/* For erase and more data add two to b's buffer_data count.*/
+	if (b->head->next == NULL) {
+		iov_alloc = sizeof(small_iov)/sizeof(small_iov[0]);
+		iov = small_iov;
+	} else {
+		iov_alloc = ((height*(width+2))/b->size)+10;
+		iov = (struct iovec *) MALLOC(iov_alloc*sizeof(*iov));
+	}
+	iov_index = 0;
+
+	/* Previously print out is performed. */
+	if (erase_flag) {
+		iov[iov_index].iov_base = erase;
+		iov[iov_index].iov_len = sizeof erase;
+		iov_index++;
+	}
+
+	/* Output data. */
+	column = 1;  /* Column position of next character displayed. */
+	for (data = b->head; data && (height > 0); data = data->next) {
+		size_t cp;
+
+		cp = data->sp;
+		while ((cp < data->cp) && (height > 0)) {
+			/* Calculate lines remaining and column position after displaying
+			 * this character. */
+			if (data->data[cp] == '\r') {
+				column = 1;
+			} else if ((data->data[cp] == '\n') || (column == width)) {
+				column = 1;
+				height--;
+			} else {
+				column++;
+			}
+			cp++;
+		}
+
+		iov[iov_index].iov_base = (char *)(data->data + data->sp);
+		iov[iov_index++].iov_len = cp-data->sp;
+		data->sp = cp;
+
+        	/* This should not ordinarily happen. */
+		if (iov_index == iov_alloc) {
+			iov_alloc *= 2;
+			if (iov != small_iov) {
+				iov = REALLOC(iov, iov_alloc*sizeof(*iov));
+			} else {
+				/* This should absolutely never occur. */
+				iov = MALLOC(iov_alloc*sizeof(*iov));
+				memcpy(iov, small_iov, sizeof(small_iov));
+			}
+		}
+	}
+
+	/* In case of `more' display need. */
+	if (b->tail && (b->tail->sp < b->tail->cp) && !no_more_flag) {
+		iov[iov_index].iov_base = more;
+		iov[iov_index].iov_len = sizeof more;
+		iov_index++;
+	}
+
+
+#ifdef IOV_MAX
+	/* IOV_MAX are normally defined in <sys/uio.h> , Posix.1g.
+	 * example: Solaris2.6 are defined IOV_MAX size at 16.
+	 */
+	{
+		struct iovec *c_iov = iov;
+
+		while (iov_index > 0) {
+			int iov_size;
+
+			iov_size = ((iov_index > IOV_MAX) ? IOV_MAX : iov_index);
+			if ((nbytes = writev(fd, c_iov, iov_size)) < 0) {
+				break;
+			}
+
+			/* move pointer io-vector */
+			c_iov += iov_size;
+			iov_index -= iov_size;
+		}
+	}
+#endif /* IOV_MAX */
+
+	/* Free printed buffer data. */
+	while (b->head && (b->head->sp == b->head->cp)) {
+		buffer_data_t *del;
+		if (!(b->head = (del = b->head)->next))
+			b->tail = NULL;
+		FREE(del);
+	}
+
+	if (iov != small_iov)
+		FREE(iov);
+
+	return (nbytes < 0) ? BUFFER_ERROR :
+			      (b->head ? BUFFER_PENDING : BUFFER_EMPTY);
+}
+
+/* This function (unlike other buffer_flush* functions above) is designed
+ * to work with non-blocking sockets.  It does not attempt to write out
+ * all of the queued data, just a "big" chunk.  It returns 0 if it was
+ * able to empty out the buffers completely, 1 if more flushing is
+ * required later, or -1 on a fatal write error.
+ */
+buffer_status_t
+buffer_flush_available(buffer_t *b, int fd)
+{
+/* These are just reasonable values to make sure a significant amount of
+ * data is written.  There's no need to go crazy and try to write it all
+ * in one shot. */
+#ifdef IOV_MAX
+#define MAX_CHUNKS ((IOV_MAX >= 16) ? 16 : IOV_MAX)
+#else
+#define MAX_CHUNKS 16
+#endif
+#define MAX_FLUSH 131072
+
+	buffer_data_t *d;
+	size_t written;
+	struct iovec iov[MAX_CHUNKS];
+	size_t iovcnt = 0, nbytes = 0;
+
+	for (d = b->head; d && (iovcnt < MAX_CHUNKS) && (nbytes < MAX_FLUSH);
+	     d = d->next, iovcnt++) {
+		iov[iovcnt].iov_base = d->data+d->sp;
+		nbytes += (iov[iovcnt].iov_len = d->cp-d->sp);
+	}
+
+	/* No data to flush: should we issue a warning message? */
+	if (!nbytes)
+		return BUFFER_EMPTY;
+
+	/* only place where written should be sign compared */
+	if ((ssize_t)(written = writev(fd,iov,iovcnt)) < 0) {
+		/* Calling code should try again later. */
+		if (ERRNO_IO_RETRY(errno))
+			return BUFFER_PENDING;
+		return BUFFER_ERROR;
+	}
+
+	/* Free printed buffer data. */
+	while (written > 0) {
+		buffer_data_t *d;
+		if (!(d = b->head))
+			break;
+		if (written < d->cp-d->sp) {
+			d->sp += written;
+			return BUFFER_PENDING;
+		}
+
+		written -= (d->cp-d->sp);
+		if (!(b->head = d->next))
+			b->tail = NULL;
+		FREE(d);
+	}
+
+	return b->head ? BUFFER_PENDING : BUFFER_EMPTY;
+
+#undef MAX_CHUNKS
+#undef MAX_FLUSH
+}
+
+/* Try to write this data to the file descriptor.
+ * Any data that cannot be written immediately is added to
+ * the buffer queue.
+ */
+buffer_status_t
+buffer_write(buffer_t *b, int fd, const void *p, size_t size)
+{
+	ssize_t nbytes;
+	size_t written;
+
+	/* Buffer is not empty, so do not attempt to write the new data. */
+	if (b->head) {
+		nbytes = 0;
+	} else if ((nbytes = write(fd, p, size)) < 0) {
+		if (ERRNO_IO_RETRY(errno)) {
+			nbytes = 0;
+		} else {
+			return BUFFER_ERROR;
+		}
+	}
+
+	/* Add any remaining data to the buffer. */
+	written = nbytes;
+	if (written < size) {
+		buffer_put(b, ((const char *)p)+written, size-written);
+	}
+
+	return b->head ? BUFFER_PENDING : BUFFER_EMPTY;
+}
diff -rupN keepalived-1.2.7/lib/buffer.h keepalived-1.2.7-unicast/lib/buffer.h
--- keepalived-1.2.7/lib/buffer.h	1970-01-01 01:00:00.000000000 +0100
+++ keepalived-1.2.7-unicast/lib/buffer.h	2013-05-24 10:12:36.636168800 +0200
@@ -0,0 +1,84 @@
+/*
+ * Soft:        Keepalived is a failover program for the LVS project
+ *              <www.linuxvirtualserver.org>. It monitor & manipulate
+ *              a loadbalanced server pool using multi-layer checks.
+ *
+ * Part:        buffer.c include file.
+ *
+ * Author:      Alexandre Cassen, <acassen@linux-vs.org>
+ *
+ *              This program is distributed in the hope that it will be useful,
+ *              but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ *              See the GNU General Public License for more details.
+ *
+ *              This program is free software; you can redistribute it and/or
+ *              modify it under the terms of the GNU General Public License
+ *              as published by the Free Software Foundation; either version
+ *              2 of the License, or (at your option) any later version.
+ *
+ * Copyright (C) 2001-2012 Alexandre Cassen, <acassen@linux-vs.org>
+ */
+
+#ifndef _BUFFER_H
+#define _BUFFER_H
+
+/* buffer definition */
+typedef struct _buffer_data {
+	struct _buffer_data	*next;
+
+	size_t			cp;	/* Location to add new data. */
+	size_t			sp;	/* Pointer to data not yet flushed. */
+	unsigned char		data[];	/* Actual data stream (variable length).
+					 * real dimension is buffer->size.
+					 */
+} buffer_data_t;
+
+typedef struct _buffer {
+	buffer_data_t		*head;
+	buffer_data_t		*tail;
+
+	size_t			size;	/* Size of each buffer_data chunk. */
+} buffer_t;
+
+typedef enum _buffer_status {
+	BUFFER_ERROR = -1,		/* An I/O error occurred.
+					 * The buffer should be destroyed and the
+					 * file descriptor should be closed.
+					 */
+	BUFFER_EMPTY = 0,		/* The data was written successfully,
+					 * and the buffer is now empty (there is
+					 * no pending data waiting to be flushed).
+					 */
+	BUFFER_PENDING = 1		/* There is pending data in the buffer
+					 * waiting to be flushed. Please try
+					 * flushing the buffer when select
+					 * indicates that the file descriptor
+					 * is writeable.
+					 */
+} buffer_status_t;
+
+/* Some defines */
+#define BUFFER_SIZE_DEFAULT	4096
+
+/* Some usefull macros */
+#define ERRNO_IO_RETRY(EN) \
+	(((EN) == EAGAIN) || ((EN) == EWOULDBLOCK) || ((EN) == EINTR))
+
+/* Prototypes */
+extern buffer_t *buffer_new(size_t);
+extern void buffer_reset(buffer_t *);
+extern void buffer_free(buffer_t *);
+extern void buffer_put(buffer_t *, const void *, size_t);
+extern void buffer_putc(buffer_t *, uint8_t);
+extern void buffer_putstr(buffer_t *, const char *);
+extern char *buffer_getstr(buffer_t *);
+extern int buffer_empty(buffer_t *);
+extern buffer_status_t buffer_write(buffer_t *, int fd,
+                                    const void *, size_t);
+extern buffer_status_t buffer_flush_available(buffer_t *, int fd);
+extern buffer_status_t buffer_flush_all(buffer_t *, int fd);
+extern buffer_status_t buffer_flush_window(buffer_t *, int fd, int width,
+                                           int height, int erase, int no_more);
+
+#endif
